<?php
// $Id: simple.inc,v 1.1 2006/10/12 15:16:51 sime Exp $

/**
* @file
* Partner functions to shipcalc that allow shipping costs by weight.
*
*/

/**
* Shipcalc _shipping_methods hook.
* Define the weight shipping methods.
*/
function weight_shipping_methods($type = 'domestic') {

  // TODO: Add descriptions of various shipping methods.
  $methods = array();

  $methods['weight'] = array(
    '#title' => t('weight'),
    '#description' => t('Weight Based Shipping.'),
  );

  switch ($type) {
    case 'domestic':
    default:
      $methods['weight']['Large Envelope'] = array(
        '#title' => t('Large Envelope'),
      );
      $methods['weight']['Parcel'] = array(
        '#title' => t('Parcel'),
      );
      break;
    case 'international':
      $methods['weight']['Large Envelope'] = array(
        '#title' => t('Large Envelope'),
      );
      $methods['weight']['Parcel'] = array(
        '#title' => t('Parcel'),
      );
  }

  return $methods;
}

/**
* Shipcalc _settings_form hook.
*
* Create javascript for a form for weight-specific configuration.
*/
function weight_settings_form_javascript() {

  $address = shipping_default_shipfrom();
  $country = $address['country'];

  $javascript .= "\n<script type='text/javascript'>
    function display_states() {
      ctry1p = document.getElementById('edit-weight_region_1_parcel_countries');
      ctry1e = document.getElementById('edit-weight_region_1_envelope_countries');
      ctry2p = document.getElementById('edit-weight_region_2_parcel_countries');
      ctry2e = document.getElementById('edit-weight_region_2_envelope_countries');
      display_us_states1p = 0;
      display_us_states1e = 0;
      display_us_states2p = 0;
      display_us_states2e = 0;
      for (i=0; i<ctry1p.options.length; i++) {
        if (ctry1p.options[i].selected && ctry1p.options[i].value == 'us') {
          display_us_states1p = 1;
          document.getElementById('edit-weight_region_1_parcel_states').parentNode.style.display = 'inline';
        }
      }
      for (i=0; i<ctry1e.options.length; i++) {
        if (ctry1e.options[i].selected && ctry1e.options[i].value == 'us') {
          display_us_states1e = 1;
          document.getElementById('edit-weight_region_1_envelope_states').parentNode.style.display = 'inline';
        }
      }
      for (i=0; i<ctry2p.options.length; i++) {
        if (ctry2p.options[i].selected && ctry2p.options[i].value == 'us') {
          display_us_states2p = 1;
          document.getElementById('edit-weight_region_2_parcel_states').parentNode.style.display = 'inline';
        }
      }
      for (i=0; i<ctry2e.options.length; i++) {
        if (ctry2e.options[i].selected && ctry2e.options[i].value == 'us') {
          display_us_states2e = 1;
          document.getElementById('edit-weight_region_2_envelope_states').parentNode.style.display = 'inline';
        }
      }



      if (display_us_states1p == 0) {
          document.getElementById('edit-weight_region_1_parcel_states').parentNode.style.display = 'none';
      }
      if (display_us_states1e == 0) {
          document.getElementById('edit-weight_region_1_envelope_states').parentNode.style.display = 'none';
      }
      if (display_us_states2e == 0) {
          document.getElementById('edit-weight_region_2_envelope_states').parentNode.style.display = 'none';
      }
      if (display_us_states2p == 0) {
          document.getElementById('edit-weight_region_2_parcel_states').parentNode.style.display = 'none';
      }
    }

    //this stuff allows functionality for non-JavaScript browsers
    display_states();
    document.getElementById('edit-weight_region_1_parcel_states').remove(document.getElementById('edit-weight_region_1_parcel_states').length-1);
    document.getElementById('edit-weight_region_1_envelope_states').remove(document.getElementById('edit-weight_region_1_envelope_states').length-1);
    document.getElementById('edit-weight_region_2_parcel_states').remove(document.getElementById('edit-weight_region_2_parcel_states').length-1);
    document.getElementById('edit-weight_region_2_envelope_states').remove(document.getElementById('edit-weight_region_2_envelope_states').length-1);
  </script>\n";

  return $javascript;
}

/** 
* create the form elements for envelope weight-specific configuration
*/
function weight_settings_form(&$form) {
    $form = envelope_weight_settings_form($form);
    $form = parcel_weight_settings_form($form);
}
/** 
* create the form elements for envelope weight-specific configuration
*/
function envelope_weight_settings_form(&$form) {

  // large envelope
  $form['envelope'] = array(
    '#type' => 'fieldset',
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#title' => t('large envelope settings')
  );
  $form['envelope']['weight_region_1_flat_envelope_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region One: Flat Rate Charge'),
    '#default_value' => variable_get('shipcalc_weight_region_1_flat_envelope_charge',''),
    '#required' => TRUE
  );
  $form['envelope']['weight_region_1_weight_envelope_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region One: Charge Per Additional Pound (Over 1lb)'),
    '#default_value' => variable_get('shipcalc_weight_region_1_weight_envelope_charge', ''),
    '#required' => TRUE
  );
  $country = store_build_countries();
  $form['envelope']['weight_region_1_envelope_countries'] = array(
  '#type' => 'select',
  '#title' => t('Select Region One Countries'),
  '#default_value' => variable_get('shipcalc_weight_region_1_envelope_countries',''),
  '#options' => $country,
  '#multiple' => TRUE,
  '#description' => t('description.'),
  '#attributes' => array('onChange' => 'display_states()'),
  );
  $state = store_build_states();
  $form['envelope']['weight_region_1_envelope_states'] = array(
  '#type' => 'select',
  '#title' => t('Select Region One States'),
  '#default_value' => variable_get('shipcalc_weight_region_1_envelope_states',''),
  '#options' => $state,
  '#multiple' => TRUE,
  '#description' => t('description.'),
);
  $form['envelope']['weight_region_2_flat_envelope_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region Two: Flat Rate Charge'),
    '#default_value' => variable_get('shipcalc_weight_region_2_flat_envelope_charge',''),
    '#required' => TRUE
  );
  $form['envelope']['weight_region_2_weight_envelope_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region Two: Charge Per Additional Pound (Over 1lb)'),
    '#default_value' => variable_get('shipcalc_weight_region_2_weight_envelope_charge', ''),
    '#required' => TRUE
  );
  $form['envelope']['weight_region_2_envelope_countries'] = array(
  '#type' => 'select',
  '#title' => t('Select Region Two Countries'),
  '#default_value' => variable_get('shipcalc_weight_region_2_envelope_countries',''),
  '#options' => $country,
  '#multiple' => TRUE,
  '#description' => t('description.'),
  '#attributes' => array('onChange' => 'display_states()'),
  );
  $form['envelope']['weight_region_2_envelope_states'] = array(
  '#type' => 'select',
  '#title' => t('Select Region Two States'),
  '#default_value' => variable_get('shipcalc_weight_region_2_envelope_states',''),
  '#options' => $state,
  '#multiple' => TRUE,
  '#description' => t('description.'),
);
  $form['envelope']['weight_region_3_flat_envelope_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Everywhere Else: Flat Rate Charge'),
    '#default_value' => variable_get('shipcalc_weight_region_3_flat_envelope_charge', ''),
    '#required' => TRUE
  );
  $form['envelope']['weight_region_3_weight_envelope_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Everywhere Else: Charge Per Additional Pound (Over 1lb)'),
    '#default_value' => variable_get('shipcalc_weight_region_3_weight_envelope_charge', ''),
    '#required' => TRUE
  );


  return $form;
}


/** 
* create the form elements for parcel weight-specific configuration
*/
function parcel_weight_settings_form(&$form) {

  // parcel
  $form['parcel'] = array(
    '#type' => 'fieldset',
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#title' => t('parcel settings')
  );
  $form['parcel']['weight_region_1_flat_parcel_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region One: Flat Rate Charge'),
    '#default_value' => variable_get('shipcalc_weight_region_1_flat_parcel_charge',''),
    '#required' => TRUE
  );
  $form['parcel']['weight_region_1_weight_parcel_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region One: Charge Per Additional Pound (Over 1lb)'),
    '#default_value' => variable_get('shipcalc_weight_region_1_weight_parcel_charge', ''),
    '#required' => TRUE
  );
  $country = store_build_countries();
  $form['parcel']['weight_region_1_parcel_countries'] = array(
  '#type' => 'select',
  '#title' => t('Select Region One Countries'),
  '#default_value' => variable_get('shipcalc_weight_region_1_parcel_countries',''),
  '#options' => $country,
  '#multiple' => TRUE,
  '#description' => t('description.'),
  '#attributes' => array('onChange' => 'display_states()'),
  );
  $state = store_build_states();
  $form['parcel']['weight_region_1_parcel_states'] = array(
  '#type' => 'select',
  '#title' => t('Select Region One States'),
  '#default_value' => variable_get('shipcalc_weight_region_1_parcel_states',''),
  '#options' => $state,
  '#multiple' => TRUE,
  '#description' => t('description.'),
);
  $form['parcel']['weight_region_2_flat_parcel_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region Two: Flat Rate Charge'),
    '#default_value' => variable_get('shipcalc_weight_region_2_flat_parcel_charge',''),
    '#required' => TRUE
  );
  $form['parcel']['weight_region_2_weight_parcel_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Region Two: Charge Per Additional Pound (Over 1lb)'),
    '#default_value' => variable_get('shipcalc_weight_region_2_weight_parcel_charge', ''),
    '#required' => TRUE
  );
  $form['parcel']['weight_region_2_parcel_countries'] = array(
  '#type' => 'select',
  '#title' => t('Select Region Two Countries'),
  '#default_value' => variable_get('shipcalc_weight_region_2_parcel_countries',''),
  '#options' => $country,
  '#multiple' => TRUE,
  '#description' => t('description.'),
  '#attributes' => array('onChange' => 'display_states()'),
  );
  $form['parcel']['weight_region_2_parcel_states'] = array(
  '#type' => 'select',
  '#title' => t('Select Region Two States'),
  '#default_value' => variable_get('shipcalc_weight_region_2_parcel_states',''),
  '#options' => $state,
  '#multiple' => TRUE,
  '#description' => t('description.'),
);
  $form['parcel']['weight_region_3_flat_parcel_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Everywhere Else: Flat Rate Charge'),
    '#default_value' => variable_get('shipcalc_weight_region_3_flat_parcel_charge', ''),
    '#required' => TRUE
  );
  $form['parcel']['weight_region_3_weight_parcel_charge'] = array(
    '#type' => 'textfield',
    '#title' => t('Everywhere Else: Charge Per Additional Pound (Over 1lb)'),
    '#default_value' => variable_get('shipcalc_weight_region_3_weight_parcel_charge', ''),
    '#required' => TRUE
  );

  return $form;
}

/**
* Shipcalc _settings_form_submit hook.
*
* Save data from our weight-specific configuration form.
*/
function weight_settings_form_submit(&$form) {
  global $form_values;

  if ($form_values['shipping_partner'] == 'weight') {
    variable_set('shipcalc_weight_region_1_flat_envelope_charge',
      $form_values['weight_region_1_flat_envelope_charge']);
    variable_set('shipcalc_weight_region_1_weight_envelope_charge',
      $form_values['weight_region_1_weight_envelope_charge']);
    variable_set('shipcalc_weight_region_1_envelope_countries', 
      $form_values['weight_region_1_envelope_countries']);
    variable_set('shipcalc_weight_region_1_envelope_states', 
      $form_values['weight_region_1_envelope_states']);

    variable_set('shipcalc_weight_region_2_envelope_countries', 
      $form_values['weight_region_2_envelope_countries']);
    variable_set('shipcalc_weight_region_2_envelope_states', 
      $form_values['weight_region_2_envelope_states']);
    variable_set('shipcalc_weight_region_2_flat_envelope_charge',
      $form_values['weight_region_2_flat_envelope_charge']);
    variable_set('shipcalc_weight_region_2_weight_envelope_charge',
      $form_values['weight_region_2_weight_envelope_charge']);

    variable_set('shipcalc_weight_region_3_flat_envelope_charge',
      $form_values['weight_region_3_flat_envelope_charge']);
    variable_set('shipcalc_weight_region_3_weight_envelope_charge',
      $form_values['weight_region_3_weight_envelope_charge']);


    variable_set('shipcalc_weight_region_1_flat_parcel_charge',
      $form_values['weight_region_1_flat_parcel_charge']);
    variable_set('shipcalc_weight_region_1_weight_parcel_charge',
      $form_values['weight_region_1_weight_parcel_charge']);
    variable_set('shipcalc_weight_region_1_parcel_countries', 
      $form_values['weight_region_1_parcel_countries']);
    variable_set('shipcalc_weight_region_1_parcel_states', 
      $form_values['weight_region_1_parcel_states']);

    variable_set('shipcalc_weight_region_2_parcel_countries', 
      $form_values['weight_region_2_parcel_countries']);
    variable_set('shipcalc_weight_region_2_parcel_states', 
      $form_values['weight_region_2_parcel_states']);
    variable_set('shipcalc_weight_region_2_flat_parcel_charge',
      $form_values['weight_region_2_flat_parcel_charge']);
    variable_set('shipcalc_weight_region_2_weight_parcel_charge',
      $form_values['weight_region_2_weight_parcel_charge']);

    variable_set('shipcalc_weight_region_3_flat_parcel_charge',
      $form_values['weight_region_3_flat_parcel_charge']);
    variable_set('shipcalc_weight_region_3_weight_parcel_charge',
      $form_values['weight_region_3_weight_parcel_charge']);

  }
}

/**
* Shipcalc _product_form hook.
*
* Update the product form with fields that we need.  It is possible for
* multiple carriers to define the same field -- that is fine.  So long as
* the field as the same name (ie 'product_weight'), it will only be displayed
* once, and the data will be saved and restored for use by all shipping
* partners that define it.
*/
function weight_product_form(&$form) {
  $form['shipping_data']['product_weight'] = array(
    '#type' => 'textfield',
    '#title' => t('Product weight'),
    '#description' => t('The weight of the product (in %unit)', array('%unit'=> (variable_get('shipcalc_units', 'LBS')) ? t('pounds') : t('kilograms'))),
    '#default_value' => $form['#node']->product_weight
  );
}

/**
* Shipcalc _get_rates_form hook.
*
*
*/
function weight_get_rates($txn) {
     
  // get total weight of goods
  $weight = 0;
  $method = 'Large Envelope';
  if (is_array($txn->items) && $txn->items != array()) {
    foreach ($txn->items as $item) {
      if ($item->shipping_methods['weight'][0] == "Parcel") 
  $method = 'Parcel';
      // Load product_weight into $item.
      shipping_nodeapi($item, 'load', NULL);
      if ($item->product_attributes['weight']) {
    $weight += $item->product_attributes['weight'] *
    $item->qty;
      }
    }
  }
  // subtract weight threshold (1 pound)
  $weight = $weight - 1;
  if ($weight < 0) $weight = 0;

  $ctry = $txn->address['shipping']->country;
  $state = $txn->address['shipping']->state;
  if ($method == 'Parcel') {
    $region1 = variable_get('shipcalc_weight_region_1_parcel_countries', $ctry);
    $region2 = variable_get('shipcalc_weight_region_2_parcel_countries', $ctry);
  } else {
    $region1=variable_get('shipcalc_weight_region_1_envelope_countries', $ctry);
    $region2=variable_get('shipcalc_weight_region_2_envelope_countries', $ctry);
  }


  // check which region rates we should apply
  $region1_rates = 0;
  $region2_rates = 0;
  if (in_array($ctry, $region1)) {
    // if US, check state 
    if ($ctry == "us") {
      if ($method == 'Parcel') {
        $states = variable_get('shipcalc_weight_region_1_parcel_states',$state);
      } else {
        $states=variable_get('shipcalc_weight_region_1_envelope_states',$state);
      }
      if (in_array($state, $states)) {
  $region1_rates = 1;
      }
    } else {
      $region1_rates = 1;
    }
  }
  if (in_array($ctry, $region2)) {
    // if US, check state 
    if ($ctry == "us") {
      if ($method == 'Parcel') {
        $states = variable_get('shipcalc_weight_region_2_parcel_states',$state);
      } else {
        $states=variable_get('shipcalc_weight_region_2_envelope_states',$state);
      }
      if (in_array($state, $states)) {
  $region2_rates = 1;
      }
    } else {
      $region2_rates = 1;
    }
  }


  // apply rates
  if ($region1_rates) {
    if ($method == "Parcel") {
      $flat_rate = variable_get('shipcalc_weight_region_1_flat_parcel_charge',
  '');
      $per_pound_cost = variable_get(
  'shipcalc_weight_region_1_weight_parcel_charge','');
    } else {
      $flat_rate = variable_get('shipcalc_weight_region_1_flat_envelope_charge',
      '');
      $per_pound_cost = variable_get(
  'shipcalc_weight_region_1_weight_envelope_charge','');
    }

    $rates[weight] = array(
  '#key' => weight,
  '#cost' => $flat_rate + ($per_pound_cost * $weight),
  '#currency' => variable_get('payment_symbol', '$'),
  '#method' => 'air'
      );

  } elseif ($region2_rates) {
    if ($method == "Parcel") {
      $flat_rate = variable_get('shipcalc_weight_region_2_flat_parcel_charge',
  '');
      $per_pound_cost = variable_get(
  'shipcalc_weight_region_2_weight_parcel_charge','');
    } else {
      $flat_rate = variable_get('shipcalc_weight_region_2_flat_envelope_charge',
      '');
      $per_pound_cost = variable_get(
  'shipcalc_weight_region_2_weight_envelope_charge','');
    }

    $rates[weight] = array(
  '#key' => weight,
  '#cost' => $flat_rate + ($per_pound_cost * $weight),
  '#currency' => variable_get('payment_symbol', '$'),
  '#method' => 'air'
      );

  } else {
    if ($method == "Parcel") {
      $flat_rate = variable_get('shipcalc_weight_region_3_flat_parcel_charge',
  '');
      $per_pound_cost = variable_get(
  'shipcalc_weight_region_3_weight_parcel_charge','');
    } else {
      $flat_rate = variable_get('shipcalc_weight_region_3_flat_envelope_charge',
      '');
      $per_pound_cost = variable_get(
  'shipcalc_weight_region_3_weight_envelope_charge','');
    }

    $rates[weight] = array(
  '#key' => weight,
  '#cost' => $flat_rate + ($per_pound_cost * $weight),
  '#currency' => variable_get('payment_symbol', '$'),
  '#method' => 'air'
      );
  }
 
  return $rates;
  //return -1; // returning -1 results in a 'Configuration error.'
}
